#ifdef __PCM__
#include <16F628a.H>
#endif

#ifdef __PCH__
#include <18F242.H>
#endif

#include <OSA.h>

#if defined(__OSAPICC16__) || defined(_OSAPICC12__)
#include <pic.h>
#endif

#ifdef __OSAPICC18__
#include <pic18.h>
#endif

#ifdef __OSAMCC18__
#include <p18f242.h>
#endif

volatile unsigned char counter;

//------------------------------------------------------------------------------

extern 
void Task_T9 (void)
{
    for (;;)
    {
//LABEL_START:
//        OS_Yield();
//        OS_Yield();
//        OS_Yield();
//        OS_Yield();
        OS_Yield();
        OS_Bsem_Set(0);
        OS_Bsem_Set(1);
        OS_Bsem_Set(2);
        OS_Yield();

    }
}


//------------------------------------------------------------------------------
void Task_T0 (void)
{for (;;) {
    OS_Bsem_Wait(0);
    counter++;
}}

//------------------------------------------------------------------------------
void Task_T1 (void)
{for (;;) {
    OS_Bsem_Wait(1);
    counter++;
}}

//------------------------------------------------------------------------------
void Task_T2 (void)
{for (;;) {
    OS_Bsem_Wait(2);
    counter++;
}}

//------------------------------------------------------------------------------
void Task_T3 (void)
{for (;;) {
    OS_Bsem_Wait(2);
    counter++;
}}

//------------------------------------------------------------------------------
void Task_T4 (void)
{for (;;) {
    OS_Bsem_Wait(2);
    counter++;
}}

//------------------------------------------------------------------------------
void Task_T5 (void)
{for (;;) {
    OS_Bsem_Wait(2);
    counter++;
}}

//------------------------------------------------------------------------------
void Task_T6 (void)
{for (;;) {
    OS_Bsem_Wait(2);
    counter++;
}}

//------------------------------------------------------------------------------
void Task_T7 (void)
{for (;;) {
    OS_Bsem_Wait(2);
    counter++;
}}

//------------------------------------------------------------------------------
void Task_T8 (void)
{for (;;) {
    OS_Bsem_Wait(2);
    counter++;
}}
//------------------------------------------------------------------------------

#ifdef __OSAMIKROC__

    #pragma funcall main Task_T0
    #pragma funcall main Task_T1
    #pragma funcall main Task_T2
    #pragma funcall main Task_T3
    #pragma funcall main Task_T4
    #pragma funcall main Task_T5
    #pragma funcall main Task_T6
    #pragma funcall main Task_T7
    #pragma funcall main Task_T8
    #pragma funcall main Task_T9

#endif


static volatile __osa_uint16    dwSpeedCounter;
void main (void)
{
    char            cTestMode;


    OS_Init();
    
    cTestMode = 3;

    #ifdef __OSACCS__
        OS_Task_Reserve(Task_T0);
        OS_Task_Reserve(Task_T1);
        OS_Task_Reserve(Task_T2);
        OS_Task_Reserve(Task_T3);
        OS_Task_Reserve(Task_T4);
        OS_Task_Reserve(Task_T5);
        OS_Task_Reserve(Task_T6);
        OS_Task_Reserve(Task_T7);
        OS_Task_Reserve(Task_T8);
        OS_Task_Reserve(Task_T9);
    #endif

    switch (cTestMode)
    {
        case 1:

            OS_Task_Create(3, Task_T0);
            OS_Task_Create(0, Task_T1);
            OS_Task_Create(3, Task_T2);
            OS_Task_Create(5, Task_T3);
            OS_Task_Create(4, Task_T4);
            #ifndef __OSAPICC12__
                OS_Task_Create(3, Task_T5);
                OS_Task_Create(6, Task_T6);
            #endif
            OS_Task_Create(2, Task_T7);
            OS_Task_Create(4, Task_T8);
            OS_Task_Create(7, Task_T9);
            break;
    
        case 2:

            OS_Task_Create(2, Task_T0);
            OS_Task_Create(2, Task_T1);
            OS_Task_Create(2, Task_T2);
            OS_Task_Create(2, Task_T3);
            OS_Task_Create(2, Task_T4);
            #ifndef __OSAPICC12__
                OS_Task_Create(2, Task_T5);
                OS_Task_Create(2, Task_T6);
            #endif
            OS_Task_Create(2, Task_T7);
            OS_Task_Create(2, Task_T8);
            OS_Task_Create(2, Task_T9);
            break;
    
        case 3:

            OS_Task_Create(0, Task_T0);
            OS_Task_Create(0, Task_T1);
            OS_Task_Create(0, Task_T2);
            OS_Task_Create(0, Task_T3);
            OS_Task_Create(0, Task_T4);
            #ifndef __OSAPICC12__
                OS_Task_Create(0, Task_T5);
                OS_Task_Create(0, Task_T6);
            #endif
            OS_Task_Create(0, Task_T7);
            OS_Task_Create(0, Task_T8);
            OS_Task_Create(0, Task_T9);
    
            break;
    
        case 4:

            OS_Task_Create(6, Task_T0);
            OS_Task_Create(5, Task_T1);
            OS_Task_Create(4, Task_T2);
            OS_Task_Create(3, Task_T3);
            OS_Task_Create(2, Task_T4);
            #ifndef __OSAPICC12__
                OS_Task_Create(1, Task_T5);
                OS_Task_Create(6, Task_T6);
            #endif
            OS_Task_Create(5, Task_T7);
            OS_Task_Create(4, Task_T8);
            OS_Task_Create(7, Task_T9);
    
            break;
    }

    *((char*)&OS_Flags) &= ~0x80;

SPEED_TEST_LABEL:               
        dwSpeedCounter = 0;         
    
    for (;;)
    {
        dwSpeedCounter++;
        if (dwSpeedCounter >= 10000) goto SPEED_TEST_LABEL;

        OS_CLRWDT();
        OS_Sched();
    }
}
